"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactBootstrapTypeahead = require("react-bootstrap-typeahead");

var _selectn = require("selectn");

var _selectn2 = _interopRequireDefault(_selectn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MenuItem = function MenuItem(_ref) {
  var key = _ref.key,
      name = _ref.name;

  return _react2.default.createElement(
    "div",
    { key: key },
    _react2.default.createElement(
      "span",
      null,
      name
    )
  );
};

var DEFAULT_OPTIONS = {
  required: false,
  labelKey: "name",
  minLength: 3,
  renderMenuItemChildren: MenuItem,
  placeholder: "Search..."
};

var toDefault = function toDefault(_ref2) {
  var properties = _ref2.properties;

  var defVal = Object.keys(properties).reduce(function (agg, field) {
    if (properties[field].default !== undefined) {
      agg[field] = properties[field].default;
    }
    return agg;
  }, {});
  return defVal;
};

var toSchemaEvents = function toSchemaEvents(events, _ref3) {
  var schema = _ref3.schema,
      responseSchemaMapping = _ref3.uiSchema.typeahead.responseSchemaMapping;

  if (!responseSchemaMapping) {
    return events;
  }
  var defVal = toDefault(schema.properties ? schema : schema.items);
  var schemaEvents = events.map(function (event) {
    var schEvent = Object.keys(responseSchemaMapping).reduce(function (agg, field) {
      var schemaField = responseSchemaMapping[field];
      agg[schemaField] = event[field];
      return agg;
    }, {});
    return Object.assign({}, defVal, schEvent);
  });
  return schemaEvents;
};

var AsyncTypeaheadField = function (_Component) {
  _inherits(AsyncTypeaheadField, _Component);

  function AsyncTypeaheadField(props) {
    _classCallCheck(this, AsyncTypeaheadField);

    var _this = _possibleConstructorReturn(this, (AsyncTypeaheadField.__proto__ || Object.getPrototypeOf(AsyncTypeaheadField)).call(this, props));

    _this.handleSearch = function (query) {
      if (!query) {
        return;
      }

      var _this$props$uiSchema$ = _this.props.uiSchema.typeahead,
          url = _this$props$uiSchema$.url,
          optionsMapping = _this$props$uiSchema$.optionsMapping;


      fetch(url, {
        method: "POST",
        body: JSON.stringify({
          Name: query
        })
      }).then(function (resp) {
        return resp.json();
      }).then(function (json) {
        return optionsMapping ? (0, _selectn2.default)(optionsMapping, json) : json;
      }).then(function (options) {
        return _this.setState({ options: options });
      });
    };

    _this.handleSelectionChange = function (events) {
      if (events.length > 0) {
        var schemaEvents = toSchemaEvents(events, _this.props);
        _this.props.onChange(schemaEvents);
        setTimeout(function () {
          return _this.refs.typeahead.getInstance().clear();
        }, 0);
      }
    };

    _this.state = {
      options: []
    };
    return _this;
  }

  _createClass(AsyncTypeaheadField, [{
    key: "render",
    value: function render() {
      var typeahead = this.props.uiSchema.typeahead;


      var typeConf = Object.assign({}, DEFAULT_OPTIONS, typeahead);
      typeConf.onChange = this.handleSelectionChange;
      typeConf.onSearch = this.handleSearch;
      typeConf.options = this.state.options;
      typeConf.ref = "typeahead";

      return _react2.default.createElement(_reactBootstrapTypeahead.AsyncTypeahead, typeConf);
    }
  }]);

  return AsyncTypeaheadField;
}(_react.Component);

exports.default = AsyncTypeaheadField;